<?php

namespace ACL\Repositories;

use ACL\Traits\TQuery;
use ACL\Helpers\Instances\InstanceProvider;
use Doctrine\DBAL\Driver\Exception;
use Doctrine\ORM\EntityManager;

class Organizacaooper extends RepositoryBase {

    Use TQuery;

    protected $table = 'ORGANIZACAOOPER';

    /** @var EntityManager */
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        parent::__construct($this->table);
        $this->entityManager = $entityManager;
    }

    public function createOrganizacaooper($nrorganizacaooper, $nrorgrel, $cdoperador,
                                          $organizationId, $cdoperinclusao, $idativo)
    {
        $query = "INSERT INTO ORGANIZACAOOPER
                              (NRORGANIZACAOOPER, NRORGREL, CDOPERADOR, DTINCLUSAO, NRORGINCLUSAO,
                               CDOPERINCLUSAO, NRORG, IDATIVO)
                       VALUES (:NRORGANIZACAOOPER, :NRORGREL, :CDOPERADOR, SYSDATE, :NRORG,
                               :CDOPERINCLUSAO, :NRORG, :IDATIVO)";

        $params = array (
            "NRORGANIZACAOOPER" => $nrorganizacaooper,
            "NRORGREL"         => $nrorgrel,
            "CDOPERADOR"        => $cdoperador,
            "CDOPERINCLUSAO"    => $cdoperinclusao,
            "NRORG"             => $organizationId,
            "IDATIVO"           => $idativo
        );

        try {
            $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
            $std->executeQuery($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage(), 500);
        };
    }

    /**
     * @param $nrorgrel
     * @param $cdoperador
     * @param $nrorg
     * @throws Exception
     */
    public function deleteOrganizacaooper($nrorgrel, $cdoperador, $nrorg)
    {
        $query = "DELETE 
                    FROM ORGANIZACAOOPER
                   WHERE NRORGREL   = :NRORGREL
                     AND CDOPERADOR = :CDOPERADOR
                     AND NRORG      = :NRORG";

        $params = array(
            'CDOPERADOR' => $cdoperador,
            'NRORGREL'   => $nrorgrel,
            'NRORG'      => $nrorg
        );

        try {
            $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
            $std->executeQuery($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage(), 500);
        };
    }
}
